<!--#include virtual="/.narodsys/metrika_counter.html"-->
<i style="background:url(//www.tns-counter.ru/V13a****yandex_ru/ru/CP1251/tmsec=narod_total/0)"></i>
<!--#include virtual="/.narodsys/direct.html"-->
//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#define SPEED_LIMIT 240

int read_word(char *,char ,char *);
void replace_word(char *,char ,char *);
void feed_convert(int ,int ,char *);

/*                 */
int main(int argc, char* argv[])
{
  char *plent,*name;
  FILE 	*inp,*out;
  float	x,xn,y,yn;
  int	f,fn,mode,move,new_move,feed_set;
  char	s_curr[80],*curr,s_next[80],*next,new_feed[10];
  char	word_x[10],word_y[10],word_f[5];

 printf("\n\nProgram: n33.exe ; Author : Chizh O.N. (Moscow, 1997 year)");
 printf("\nCoding feed and slowdn for control program H33 (Ataka)");
 printf("\nFormat: exe file1.up file2.up \n\n");

 switch(argc)
 {
  case 2:
   if (!(strcmp(argv[1], "/?"))) {
    printf("\nFormat:");
    printf("\n here");
    printf("\n <arg1> - name input file (*.up) ");
    printf("\n <arg2> - name output file (*.up)");
    printf("\n 1) exe <arg1> <arg2>");
    printf("\n 2) exe <arg1>       ");
    printf("\n\t then <arg2>=temp.up");
    return 0 ;
    } else {
   	name=argv[1];
   	strcpy(plent,"temp.tap\0");
   }
   break ;
  case 3: {  name=argv[1]; plent=argv[2]; }
   break ;
  default:
    return (0);
   break ;
 }

  /*if (argc<3) { printf("Usage: n33 inpfile outfile \n");
                exit(0);
              }*/

  inp=fopen(name,"r");
  if (inp==NULL) { printf(" input file=<%s> not found\n",name); exit(0); }

  out=fopen(plent,"w");
  if (out==NULL) { printf(" output file=<%s> not created\n",plent); exit(0); }


   /* scaning input file */

   curr=fgets(s_curr,79,inp); next=fgets(s_next,79,inp);

   while (curr!=NULL)
   {
     move=feed_set=0;
     x=0.0; y=0.0;
     if (read_word(curr,'X',word_x)) { sscanf(word_x,"%lf",&x);     move=1; }
     if (read_word(curr,'Y',word_y)) { sscanf(word_y,"%lf",&y);     move=1; }
     if (read_word(curr,'F',word_f)) { sscanf(word_f,"%d",&f); feed_set=1; }

     mode=0;
     if (!move || next==NULL) mode=0;
     else
     {

      xn=0.0; yn=0.0;
      if (read_word(next,'X',word_x)) { new_move=1; sscanf(word_x,"%lf",&xn); }
      if (read_word(next,'Y',word_y)) { new_move=1; sscanf(word_y,"%lf",&yn); }

      read_word(next,'F',word_f); sscanf(word_f,"%d",&fn);
      if (new_move)
      {
	if ( (f  > SPEED_LIMIT) &&
	     (fn > SPEED_LIMIT) &&
	     (x*xn+y*yn) <=0.0      ) mode=4;
      }
     }
     if (feed_set || mode)
     {
       feed_convert(f,mode,new_feed);
       replace_word(curr,'F',new_feed);
     }

/* write the new_string in output file */

     fputs(curr,out);
     if (next!=NULL) strcpy(curr,next);
     else curr=NULL;
     next=fgets(s_next,79,inp);
   }

    fclose(inp); fclose(out);

    printf("\n\nReady ....\nFile= %s created.",plent);

    return (0);
}

/* This function read the numeric string after key letter
   in success it return 1, otherwice 0*/
int read_word(char *s,char w,char *sw)
{   char *word,sym;
    int  n;

    if ((word=strchr(s,w))==NULL) return(0);
    n=0;
    do
    {  sym=*(word+(n+1));
       if (isdigit(sym)||sym==' '||sym=='+'||sym=='-'||sym=='.') n++;
       else break;
    } while (1);
    if (n>0){ strncpy(sw,word+1,n); sw[n]='\0'; return(n); }
    else                                        return(0);
}

/* This function replace the numeric string after key letter
   if there isn't a key letter in a string funktion adds it
   at the end of a string*/

void replace_word(char *s,char w,char *sw)
{
  int n,n1;
  char old_sw[20],save[100],*p;

  n1=read_word(s,w,old_sw);
  if ((n=read_word(s,w,old_sw))!=0)
  {
    /* replace word */
    p=strchr(s,w);
    *(p+1)='\0'; strcpy(save,p+n+1);
    strcat(strcat(s,sw),save);
  }
  else
  {
    /* add word at the end of string */

		   p=strchr(s,'<') ; /* string have <CR> or <LF> as text */
    if (p==NULL)   p=strchr(s,'\r'); /* string have \r\n */
    if (p==NULL)   p=strchr(s,'\n'); /* string have \n   */
    if (p!=NULL)
    { strcpy(save,p); *p=w; *(p+1)='\0'; strcat(strcat(s,sw),save); }
    else
    {
      save[0]=w; save[1]='\n'; save[2]='\0'; strcat(strcat(s,save),sw); }
  }
}


/*  This function code the feed value for N33 numeric control*/
void feed_convert(int f,int mode,char *new_feed)
{ int k;
  k=log10((double)f);
  if (k>1) f/=pow(10.0,(double)k-1);
  sprintf(new_feed,"%1d%1d%02d",mode,k+4,f);
  k=0;
}

//---------------------------------------------------------------------------
 